var hash;
var latest;
var current;
var hist;

function init(_hash, _latest) {
  hash=_hash;
  current=_latest;
  latest=_latest;
  hist=new Array();
  
  $("#doing").ajaxStart(function(){
			$(this).css("visibility", "visible");
			enableHistControls(false);
		}).ajaxComplete(function(){
			$(this).css("visibility", "hidden");
			enableHistControls(true);
		});
  $(".editable").click(function(){
      if (current != latest) {
        diff(latest);
        return;
      }
      var div=this;
      var p=$(div).position();
      var w=$(div).outerWidth();
      var h=$(div).outerHeight();
      var id=$(div).attr("id");
      var txt=$(div).html();
      var area=$("<textarea style=\"position:absolute;z-index:1;text-align:left;font-size:12px;left:"+p.left+"px;top:"+p.top+"px;width:"+w+"px;height:"+h+"px;\" >"+txt+"</textarea>");
      $(area).blur(function(){
        $(area).unbind("blur");
        $(area).unbind("keypress");
        var ntxt=saveReplace($(area).val());
        if (txt != ntxt) {
          $(div).html(ntxt);
          writeEntry(id, ntxt, div, txt);
        }
        $(area).detach();
      });
      $(area).keypress(function(event) {
        if (event.keyCode == '13') {
          $(area).unbind("blur");
          $(area).unbind("keypress");
          event.preventDefault();
          var ntxt=saveReplace($(area).val());
          if (txt != ntxt) {
            $(div).html(ntxt);
            writeEntry(id, ntxt, div, txt);
          }
          $(area).detach();
        } else if (event.keyCode == '27') {
          $(area).unbind("blur");
          $(area).unbind("keypress");
          $(area).detach();
        }
      });
      $(area).appendTo($(div).offsetParent());
      $(area).focus();
  });
  
  $("#end").click(function() {
    if (latest!=current && ($("#end").attr("src").match("graphics/e.png$")=="graphics/e.png")) {
      diff(latest);
    }
  });
  $("#back").click(function() {
    if (latest!=current && ($("#back").attr("src").match("graphics/b.png$")=="graphics/b.png")) {
      diff(hist[hist.indexOf(current)-1]);
    }
  });
  $("#forward").click(function() {
    if (hist.length > 1 && (hist[hist.length-1]!=current) && ($("#forward").attr("src").match("graphics/f.png$")=="graphics/f.png")) {
      diff(hist[hist.indexOf(current)+1]);
    }
  });
  $("#start").click(function() {
    if (hist.length > 1 && (hist[hist.length-1]!=current) && ($("#start").attr("src").match("graphics/s.png$")=="graphics/s.png")) {
      diff(hist[hist.length-1]);
    }
  });
  
  window.setInterval("updateHistory()", 60000);
  updateHistory();
}

function saveReplace(text) {
  return text.replace(/'/g, "&apos;").replace(/"/g, "&quot;");
}

function enableHistControls(enable) {
  if (enable) {
    if (latest!=current) {
      $("#end").attr("src", freifeld_ajax_base+"graphics/e.png");
      $("#back").attr("src", freifeld_ajax_base+"graphics/b.png");
    }
    if (hist.length > 1 && (hist[hist.length-1]!=current)) {
      $("#forward").attr("src", freifeld_ajax_base+"graphics/f.png");
      $("#start").attr("src", freifeld_ajax_base+"graphics/s.png");
    }
  } else {
    $("#end").attr("src",freifeld_ajax_base+"graphics/de.png");
    $("#back").attr("src",freifeld_ajax_base+"graphics/db.png");
    $("#forward").attr("src",freifeld_ajax_base+"graphics/df.png");
    $("#start").attr("src",freifeld_ajax_base+"graphics/ds.png");
  }
}

function setInputValues() {
}

function setCurrent(b) {
  current=b;
  $("#current").html(current);
}

function updateHistory() {
  var isLatest=(current==latest);
  $.ajax({
        url:freifeld_ajax, type: "POST", async:true, dataType: "json",
        data: ({ "do": "getHistory", "hash": hash }),
        success: function(data){
          var s="";
          var nhist=new Array();
          for(var i=0; i < data.c; i++) {
            var h=eval("data.h"+i);
            nhist.push(h);
            s+="<a href=\"javascript:diff('"+h+"');\" title=\""+h+"\">&middot;</a>";
          }
          hist=nhist;
          if (hist.length > 0) {
            latest=hist[0];
            $("#latest").html(latest);
          }
          $("#history").html(s);
          if (isLatest) {
            diff(latest);
          }
        }, error: function(req, status, error) {
          // alert("update history failed: "+error+" "+status);
        }});
}

function writeEntry(n, v, div, old) {
   $.ajax({
        url:freifeld_ajax, type: "POST", async:true, dataType: "html",
        data: ({ "do": "writeEntry", "hash": hash, "name": n, "value":  saveMask(v) }),
        success: function(msg){
          // alert("written");
          updateHistory();
        }, error: function(req, status, error) {
          $(div).html(old);
        }});
}

function diff(to) { 
  if (current != to) {
    $.ajax({
        url:freifeld_ajax, type: "POST", async:true, dataType: "json",
        data: ({ "do": "getDiff", "hash": hash, "from": current, "to": to }),
        success: function(data){
          for (n in data) {
            if (n != "ts") {
              $("#"+n).html(data[n]);
            }
          }
          setCurrent(data.ts);
        }, error: function(req, status, error) {
          alert("failed: "+error+" "+status);
        }});
  }
}

function saveMask(s) {
  return s.replace(/_/g, "_u").replace(/</g, "_l").replace(/>/g, "_g").replace(/'/g, "_a").replace(/"/g, "_q").replace(/&apos;/g, "_a").replace(/&quot;/g, "_q");
}
